/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2004 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_TASKBARBUTTON_H__80A0FBD2_FB89_4557_822D_0E5BB681EC99__INCLUDED_)
#define AFX_TASKBARBUTTON_H__80A0FBD2_FB89_4557_822D_0E5BB681EC99__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef vector<HWND> hWndGroupList;
typedef vector<HWND>::iterator hWndGroupListIterator;
 
class TaskbarButton  
{
	friend class Taskbar;

public:

	TaskbarButton( Taskbar *actualtaskbar, HWND hWnd );
	virtual ~TaskbarButton();

private:

	//Grouping
	//--------------------------------------------------
	hWndGroupList hwndgrouplist;

	void AddToGroup( HWND add_hTask )
	{
		hwndgrouplist.insert(hwndgrouplist.end(), add_hTask);
	};

	BOOL SearchInGroup( HWND search_hTask )
	{
		for(hWndGroupListIterator hglit = hwndgrouplist.begin(); hglit != hwndgrouplist.end(); ++hglit)
		{
			if ( *hglit == search_hTask )
				return TRUE;
		}
		return FALSE;
	};

	BOOL RemoveFromGroup( HWND remove_hTask )
	{
		for(hWndGroupListIterator hglit = hwndgrouplist.begin(); hglit != hwndgrouplist.end(); ++hglit)
		{
			if ( (*hglit) == remove_hTask )
			{
				delete (*hglit);
				hwndgrouplist.erase( hglit );

				hButtonTask = (*hwndgrouplist.begin());

				return true;
			}
		}
		return false;
	};
	//--------------------------------------------------

	Taskbar *taskbar;

	HWND hButtonTask;
	string classname;
	string caption;
	string tooltip;

	int buttonx;
	int buttony;
	int buttonwidth;
	int buttonheight;

	void setButtonLayout( int x, int y, int width, int height );
	BOOL HasPoint( int xP, int yP );

	BOOL onUpdate(bool needRedraw = false);

	string GetWindowCaption( HWND check_hTask = NULL );

	bool useHover;
	int position;

	int currentState;
	int getCurrentState();

	bool flashNow; //Start/Stop Flashing every Second

	void SetFlashing(bool flash)
	{
		flashNow = flash;
	};

	BOOL GetFlashing()
	{
		return flashNow;
	};

	void onButtonClick( int x, int y, int action, bool minimize = false );	
	void Select(bool minimize);
	void GroupMenu();
	void Menu();

	void onPaint( HDC destDC );

protected:

	HICON icon;

};

#endif // !defined(AFX_TASKBARBUTTON_H__80A0FBD2_FB89_4557_822D_0E5BB681EC99__INCLUDED_)
